# global imports (dont't worry, red is normal)
from db.repository import Repository
from db.entities.user import User

from flask import request, Response
import bcrypt

from datetime import datetime

repository = Repository()

def authenticate():
    data = request.json
    username = data["username"]

    user = repository.one_by_username(username)

    # return 400 if the user does not exist
    if len(user) == 0:
        return Response(status = 400, response=f'User with username "{username}" does not exist')
    
    user = User.from_serializable_dict(user[0])
    
    hashed_password = user.password
    actual_password = data["password"]

    if bcrypt.checkpw(actual_password.encode("utf-8"), hashed_password.encode("utf-8")):
        # TODO token generation
        return "Nice"
    
    return Response(status = 400, response=f'Wrong credentials for user "{username}"')

def delete(username):
    reference_users = repository.one_by_username(username)

    # return 400 if the user does not exist
    if len(reference_users) == 0:
        return Response(status = 400, response=f'User with username "{username}" does not exist')
    
    repository.delete_all_with_username(username)
    return Response(status=200)

def add():
    data = request.json

    if not "role" in data:
        data["role"] = "u"
    
    username = data["username"]

    reference_users = repository.one_by_username(username)

    # return 400 if the user already exists
    if len(reference_users) > 0:
        return Response(status = 400, response=f'User with username "{username}" already exists')
    
    data["created_at"] = str(datetime.now())
    data["last_login"] = "0"

    print(data["password"])

    data["password"] = bcrypt.hashpw(data["password"].encode("utf-8"), bcrypt.gensalt()).decode("utf-8")

    user = User.from_serializable_dict(data)

    repository.add(user)

    return Response(status=200)

def all():
    '''
    return all users stored in the DB
    '''

    users = repository.all()

    return str(users)